"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.GeoJSONTransform = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();
/* eslint class-methods-use-this: 0 */


exports.getLuma = getLuma;
exports.getTheme = getTheme;

var _react = require("react");

var React = _interopRequireWildcard(_react);

var _leaflet = require("leaflet");

var _leaflet2 = _interopRequireDefault(_leaflet);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var MIMETYPE = "application/geo+json";

_leaflet2.default.Icon.Default.imagePath = "../node_modules/leaflet/dist/images/";

function getLuma(el) {
  // https://en.wikipedia.org/wiki/Luma_(video)
  var style = window.getComputedStyle(el);

  var _style$backgroundColo = style.backgroundColor.replace(/^(rgb|rgba)\(/, "").replace(/\)$/, "").replace(/\s/g, "").split(","),
      _style$backgroundColo2 = _slicedToArray(_style$backgroundColo, 3),
      r = _style$backgroundColo2[0],
      g = _style$backgroundColo2[1],
      b = _style$backgroundColo2[2];
  // Digital ITU BT.601
  // http://www.itu.int/rec/R-REC-BT.601


  var y = 0.299 * r + 0.587 * g + 0.114 * b;
  return y / 255;
}

function getTheme() {
  var theme = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : "light";
  var el = arguments[1];

  switch (theme) {
    case "light":
    case "dark":
      return theme;
    default:
      if (getLuma(el) < 0.5) {
        return "dark";
      }
      return "light";
  }
}

var GeoJSONTransform = exports.GeoJSONTransform = function (_React$Component) {
  _inherits(GeoJSONTransform, _React$Component);

  function GeoJSONTransform() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, GeoJSONTransform);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = GeoJSONTransform.__proto__ || Object.getPrototypeOf(GeoJSONTransform)).call.apply(_ref, [this].concat(args))), _this), _this.getTileLayer = function () {
      if (!_this.el) return;
      var theme = getTheme(_this.props.theme, _this.el);
      // const urlTemplate = (this.props.metadata && this.props.metadata.url_template) ||
      //   'https://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png';
      var urlTemplate = _this.props.metadata && _this.props.metadata.url_template || "https://api.tiles.mapbox.com/v4/{id}/{z}/{x}/{y}.png?access_token=pk.eyJ1IjoibWlja3QiLCJhIjoiLXJIRS1NbyJ9.EfVT76g4A5dyuApW_zuIFQ";
      // const layerOptions = (this.props.metadata && this.props.metadata.layer_options) || {
      //   attribution: 'Map data (c) <a href="https://openstreetmap.org">OpenStreetMap</a> contributors',
      //   minZoom: 0,
      //   maxZoom: 18
      // };
      var layerOptions = _this.props.metadata && _this.props.metadata.layer_options || {
        attribution: '&copy; <a href="https://www.openstreetmap.org/copyright">OpenStreetMap</a>',
        id: "mapbox." + theme
      };
      return [urlTemplate, layerOptions];
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(GeoJSONTransform, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.map = _leaflet2.default.map(this.el);
      this.map.scrollWheelZoom.disable();
      this.tileLayer = _leaflet2.default.tileLayer.apply(_leaflet2.default, _toConsumableArray(this.getTileLayer())).addTo(this.map);
      var geoJSON = this.props.data;
      this.geoJSONLayer = _leaflet2.default.geoJson(geoJSON).addTo(this.map);
      this.map.fitBounds(this.geoJSONLayer.getBounds());
    }
  }, {
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(nextProps) {
      if (nextProps.theme !== this.props.theme || this.props.data !== nextProps.data) {
        return true;
      }
      return false;
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      if (prevProps.theme !== this.props.theme) {
        this.map.removeLayer(this.tileLayer);
        this.tileLayer = _leaflet2.default.tileLayer.apply(_leaflet2.default, _toConsumableArray(this.getTileLayer())).addTo(this.map);
      }
      if (prevProps.data !== this.props.data) {
        var geoJSON = this.props.data;
        this.map.removeLayer(this.geoJSONLayer);
        this.geoJSONLayer = _leaflet2.default.geoJson(geoJSON).addTo(this.map);
        this.map.fitBounds(this.geoJSONLayer.getBounds());
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      return React.createElement(
        React.Fragment,
        null,
        React.createElement("link", {
          rel: "stylesheet",
          href: "../node_modules/leaflet/dist/leaflet.css"
        }),
        React.createElement("div", {
          ref: function ref(el) {
            _this2.el = el;
          },
          style: { height: 600, width: "100%" }
        })
      );
    }
  }]);

  return GeoJSONTransform;
}(React.Component);

GeoJSONTransform.defaultProps = {
  theme: "light"
};
GeoJSONTransform.MIMETYPE = MIMETYPE;
exports.default = GeoJSONTransform;